using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;

public class SimpleDictionary : Form {

private Label lblDict;
private Button search;
private ComboBox dict;
private TextBox word;
private TextBox r1,r2;
private Panel p12;

public SimpleDictionary( ){

  lblDict = new Label ( );
  search = new Button ( );
  dict = new ComboBox ( );
  word = new TextBox ( );
  r1 = new TextBox ( );
  r2 = new TextBox ( );
  p12 = new Panel();
  Text = " Simple dictionary application";
  
  lblDict.Location = new Point (20, 8);
  lblDict.Text = "Dictionary";
  lblDict.Size = new Size (70, 20);
  
  dict.Location = new Point (100,5);
  dict.Size = new Size (250, 25);
  
  String path=Environment.CurrentDirectory+"\\data";
  String[] lin=new String[4];
  lin[0]=" No dictionaries found in the \"data\" directory.";
  lin[1]=" You can download free dictionaries at http://www.dicts.info/uddl.php";
  if(Directory.Exists(path)){
    DirectoryInfo di = new DirectoryInfo(path);
    FileInfo[] fi = di.GetFiles(); 
    if(fi.Length>0){
      for(int i=0; i<fi.Length; i++) dict.Items.Add(fi[i]);
      lin[0]=" Download full versions of dictionaries for free at";
      lin[1]=" http://www.Dicts.info";
      lin[2]=" Hundreds of dictionaries are available";
      lin[3]=" for more than 50 languages.";
    }
  //Console.write(fi[2]);
  //if(fi[2].Length>0)
  //dict.Text = fi[2];
  
  dict.Text =fi[0].Name;
  }
  else r1.Text="\\data directory does not exist!";

  r1.Lines=lin;
  
  
  word.Location = new Point (400,5);
  word.Size = new Size (180, 25);
  word.KeyDown += new KeyEventHandler (word_Key);
  
  search.Location = new Point (610,5);
  search.Size = new Size (90, 22);
  search.Text = "&Search";
  search.Click += new EventHandler (search_Click);
  
  p12.Size = new Size(705,535);
  p12.Location = new Point(3,30);
  p12.Anchor= AnchorStyles.Left|AnchorStyles.Right|AnchorStyles.Bottom|AnchorStyles.Top;
  
  r1.Size = r2.Size = new Size (350, 515);
  r1.Multiline = r2.Multiline = true;
  r1.ScrollBars = r2.ScrollBars = ScrollBars.Both;
  r1.WordWrap = r2.WordWrap =false;
  r1.ReadOnly = r2.ReadOnly =true;
  r1.BackColor = r2.BackColor =SystemColors.Window;
  r1.Dock = DockStyle.Left;
  r2.Dock = DockStyle.Right;
  
  SuspendLayout();
  ClientSize = new Size (710, 570);
  Resize += new EventHandler(resize);
  p12.Controls.Add (r1);
  p12.Controls.Add (r2);
  Controls.AddRange(new Control[] { word,search,lblDict,dict,p12 });
  ResumeLayout(false);
}

protected void search_Click (object sender, EventArgs e){
  if(dict.Text.Length>0 && word.Text.Trim().Length>0 )
    find(dict.Text,word.Text,r1,r2);
    word.SelectAll();
}

protected void word_Key(object sender, KeyEventArgs e){
  if((int)e.KeyCode==(int)Keys.Return){
    search_Click(sender,e);
    word.SelectAll();
  }
  if((int)e.KeyCode==(int)Keys.Escape){
    word.Text="";
  }  
}

protected void resize (object sender, EventArgs e){
  r1.Width=r2.Width=p12.Width/2-3;
}

public static void find(String file, String word, TextBox r1, TextBox r2){
  
  try {
    StreamReader sr = File.OpenText("data\\"+file);
    String input;
    do{
      input=sr.ReadLine();
    }while(input=="" || input[0]=='#');
    
    int cn1=0,cn2=0;
    const int lim=300;
    String[] res1=new String[lim], res2=new String[lim];
    do{
      int pos= input.IndexOf(word);
      if(pos>=0){
        if(pos==0 || input[pos-1]=='\t' || input[pos-1]==' '){
          int d= input.IndexOf("\t");
          if(pos<d){
            if(cn1<lim){ res1[cn1]=input; cn1++; }
            pos= input.IndexOf(word,d);
          }
          if(pos>d){
            if(cn2<lim){ res2[cn2]=input; cn2++; }
          }
        }
      }
    }while((input=sr.ReadLine())!=null);
    
    String[] res=new String[cn1];
    Array.Copy(res1,res,cn1);
    r1.Lines=res;
    res=new String[cn2];
    Array.Copy(res2,res,cn2);
    r2.Lines=res;
    
    String s= "\r\n  First "+lim+" matches listed";
    if(cn1>=lim) r1.AppendText(s);
    if(cn2>=lim) r2.AppendText(s);
    sr.Close();
  }
  catch (Exception e){
    r1.Text="Error: "+e.Message;
  }
}

public static void Main( ){
  Application.Run(new SimpleDictionary( ));
}

}